﻿
using System;
using System.Runtime.CompilerServices;
using System.Runtime.ConstrainedExecution;
using System.Threading;

class Program
{
    static void Main(string[] args)
    {
        var cerThread = new Thread(() =>
        {
            try
            {
                DoInCER();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.ToString());
            }
        });

        cerThread.Start();
        cerThread.Join();

        Console.WriteLine("TEST");
    }

    private static void DoInCER()
    {
        Console.WriteLine("Can you see this message?");
        RuntimeHelpers.PrepareConstrainedRegions();
        try
        {
        }
        finally
        {
            Console.WriteLine("In finally: " + DateTime.Now);
            OutOfMemory();
            Console.WriteLine("Do Something");
        }
    }

    [ReliabilityContract(Consistency.MayCorruptInstance, Cer.Success)]
    // [ReliabilityContract(Consistency.MayCorruptInstance, Cer.MayFail)]
    // [ReliabilityContract(Consistency.MayCorruptInstance, Cer.MayFail)]
    static void OutOfMemory()
    {
        Big big;
    }
}

unsafe struct Big
{
    // public fixed byte Bytes[1_048_576];
    public fixed byte Bytes[int.MaxValue];
}
